/**************************************************************************
 * ESPFUNC.H                                                              *
 * Declares the ESP interface functions                                   *
 **************************************************************************/
Note: this material was downloaded from the Hayes BBS...
/*** NOTICE *** NOTICE *** NOTICE *** NOTICE *** NOTICE *** NOTICE ***
 ***                                                               ***
 ***                  CONFIDENTIAL INFORMATION                     ***
 ***                  ------------------------                     ***
 ***    This Document contains Confidential Information or         ***
 ***    Trade Secrets, or both, which are the property of Hayes    ***
 ***    Microcomputer Products  Inc.  This Document may not be     ***
 ***    copied, reproduced, reduced to any electronic medium or    ***
 ***    machine readable form or otherwise duplicated and the      ***
 ***    information herein may not be used, disseminated or        ***
 ***    otherwise disclosed, except with the prior written consent ***
 ***    of Hayes Microcomputer Products, Inc.                      ***
 ***                                                               ***
 *** NOTICE *** NOTICE *** NOTICE *** NOTICE *** NOTICE *** NOTICE ***/

/*
    Copyright 1991 Hayes Microcomputer Products, Inc.
    All rights reserved.
    Use of copyright notice does not imply publication.
 */

/********************************* DEFINES ********************************/

#define  BYTE              unsigned char
#define  WORD              unsigned int
#define  READ              1
#define  WRITE             0
#define  AT                0
#define  PS2               1

/* MODE BIT DEFINITIONS */
#define  UNENHANCED        0x00
#define  ENHANCED          0x01
#define  CHAR_RX           0x00
#define  DMA_RX            0x10
#define  CHAR_TX           0x00
#define  DMA_TX            0x20

/* FLOW CONTROL BITS */
#define  RX_XX_FLOW        0x01
#define  TXX_FLOW          0x02
#define  RX_RTS_FLOW       0x04
#define  RX_DTR_FLOW       0x08
#define  RTS               0x10
#define  DTR               0x20
#define  LOOP              0x40
#define  TX_XX_FLOW        0x80
#define  RX_CTS_FLOW       0x10
#define  RX_DSR_FLOW       0x20

/* UART REGISTER ADDRESSES */
#define  THR               0x0
#define  IIR               0x2
#define  LCR               0x3
#define  MCR               0x4
#define  LSR               0x5
#define  SCR               0x7
#define  DLL               0x0
#define  DLM               0x1

/* STATUS BITS */
#define  PE                0x0400
#define  FE                0x0800
#define  BI                0x1000

/* REGISTER READY BITS */
#define  RX1_RDY           0x01
#define  TX1_RDY           0x02
#define  RX2_RDY           0x04
#define  TX2_RDY           0x08
#define  STATUS1_RDY       0x10
#define  COMMAND1_RDY      0x20
#define  STATUS2_RDY       0x40
#define  COMMAND2_RDY      0x80

/* SERVICE ID BITS */
#define  RX1_FIFO_SR       0x01
#define  TX1_FIFO_SR       0x02
#define  P1_ERROR          0x04
#define  DMA_TC_REACHED    0x08
#define  RX2_FIFO_SR       0x10
#define  TX2_FIFO_SR       0x20
#define  P2_ERROR          0x40
#define  DMA_TIMEOUT       0x80

#define  TEMT              0x0200
#define  RX_TIMEOUT        0x0100

/**************************** EXTERNAL VARIABLES **************************/

extern   WORD  service_id;
extern   WORD  enhanced_base;
extern   BYTE  dmachan;
extern   BYTE  irq;
extern   BYTE  computer;
extern   WORD  register_ready;
extern   BYTE  rx_rdy;
extern   BYTE  tx_rdy;
extern   BYTE  rx_fifo;
extern   BYTE  tx_fifo;

/************************** FUNCTION DECLARATIONS *************************/

void  set_baud_rate( WORD );
void  set_line_characteristics( BYTE, BYTE, BYTE );
WORD  chksum( void );
void  reset( void );
WORD  gettest( void );
BYTE  getdips( void );
void  dload( WORD, char * );
void  setirq( BYTE );
void  setdmatime( BYTE );
void  setsrmsk( BYTE );
void  seterrormsk( WORD );
void  setfctyp( BYTE, BYTE );
void  setfcchar( BYTE, BYTE, BYTE, BYTE, BYTE );
void  setflolev( WORD, WORD );
void  settrig( WORD, WORD );
void  setrxtime( BYTE );
void  setflotime( BYTE );
void  writeuart( BYTE, BYTE );
BYTE  readuart( BYTE );
void  setpmode( BYTE );
void  cleardmasr( void );
WORD  geterrs( void );
WORD  getuarts( void );
WORD  getrxbytes( void );
WORD  gettxbytes( void );
void  dmarx( void );
void  dmatx( void );
void  xofflocal( void );
void  xonlocal( void );
void  linebreak( BYTE );
void  flushrx( void );
void  flushtx( void );
void  waitrdy( BYTE );
BYTE  rxbyte( void );
void  txbyte( BYTE );
void  initiate_dma( char *, int, BYTE );
void  set_port( BYTE );
void  init( void );
WORD  getmode( void );

